<template>
  <div class="register">
    <h1>Registrations</h1>
    <div class="main-panel">
      <form @submit.prevent="submitData">
        <div class="form-control">
          <label for="nickName">Nickname: </label>
          <input
            id="nickName"
            name="nickName"
            type="text"
            ref="nickNameInput"
            default="nickName"
          />
        </div>
        <div class="form-control">
          <label for="password">Password: </label>
          <input
            :type="showPass ? 'text' : 'password'"
            id="password"
            name="password"
            ref="passInput"
            default="title"
          />
          <label
            ><input type="checkbox" @click="showPassword($event)" />Show
            Password</label
          >
        </div>
        <p>Optional:</p>
        <div class="form-control">
          <label for="firstName">first name: </label>
          <input
            id="firstName"
            name="firstName"
            type="text"
            ref="firstNameInput"
            default="firstName"
          />
        </div>
        <div class="form-control">
          <label for="lastName">last name: </label>
          <input
            id="lastName"
            name="lastName"
            type="text"
            ref="lastNameInput"
            default="lastName"
          />
        </div>
        <div class="form-control">
          <label for="email">e-mail: </label>
          <input
            id="email"
            name="email"
            type="text"
            ref="emailInput"
            default="email"
          />
        </div>
        <button type="submit" class="btn">Register</button>
      </form>
      <div v-if="invalidForm" class="error">
        <p>
          Nickname and Password are required and have to be at least 3 marks
          length.
        </p>
      </div>
      <div v-if="errKeycloak" class="error">
        <p>Sorry registration is not available now. Please try again later</p>
      </div>
      <div v-if="successRegister" class="success">
        <p>
          You're registered successfully. You can go <a href="/">back</a> and
          login.
        </p>
      </div>
      <p>Already have account. Go back to the <a href="/">home page</a></p>
      <!-- <button @click="keycloakDellUser">Test Delete</button> -->
    </div>
  </div>
</template>

<script>
import axios from "axios";
import qs from "qs";

// secret:  ce6e990c-db4b-4c8d-ad24-b2e96f78be01

export default {
  // mounted() {
  //   this.GetToken();
  // },
  data() {
    return {
      token: "",
      lastUserAddedIp: "",
      showPass: false,
      invalidForm: false,
      errKeycloak: false,
      successRegister: false,
    };
  },
  methods: {
    async submitData() {
      this.falseAllErrorFlags();
      // e.preventDefault();
      // console.log("refs: ", this.$refs);
      const nickName = this.$refs.nickNameInput.value;
      const password = this.$refs.passInput.value;
      const firstName = this.$refs.firstNameInput.value;
      const lastName = this.$refs.lastNameInput.value;
      const email = this.$refs.emailInput.value;
      // console.log(nickName, password, firstName, lastName, email);
      if (nickName.trim().length < 3 || password.trim().length < 3) {
        this.falseAllErrorFlags();
        this.invalidForm = true;
        console.log("THIS INPUT IS IN VALID!");
        return;
      } else {
        // tududu AXIOSY KOTY SZTOSY KABANOSY!
        await this.keycloakAddUser(
          nickName,
          password,
          firstName,
          lastName,
          email
        );
        if (!this.errKeycloak) {
          this.addNewUserToMongo(nickName, firstName, lastName, email);
          this.falseAllErrorFlags();
          this.successRegister = true;
          this.clearForm();
        }
      }
    },

    async GetToken() {
      let URL = `https://cookie-keycloak.mac.pl:8082/auth/realms/test/protocol/openid-connect/token`;
      const data = {
        client_id: `admin-cli`,
        grant_type: "password",
        username: `123`,
        password: `123`,
      };
      await axios
        .post(URL, qs.stringify(data))
        .then((res) => {
          this.token = res.data.access_token;
          console.log("NOWY TOKEN WYGENEROWANY");
        })
        .catch((err) => {
          console.log("CAN NOT GET TOKEN: ", err);
          this.falseAllErrorFlags();
          this.errKeycloak = true;
        });
    },
    async keycloakAddUser(nickName, password, firstName, lastName, email) {
      await this.GetToken();
      const KEYCLOCK_URL = `https://cookie-keycloak.mac.pl:8082`;
      const KEYCLOCK_REALM_NAME = "test";
      const URL = `${KEYCLOCK_URL}/auth/admin/realms/${KEYCLOCK_REALM_NAME}/users`;
      let config = {
        headers: {
          Authorization: "Bearer " + this.token,
          "Content-Type": "application/json",
        },
      };
      const newUser = {
        firstName,
        lastName,
        email,
        username: nickName,
        enabled: true,
        credentials: [{ type: "password", value: password, temporary: false }],
      };
      await axios
        .post(URL, JSON.stringify(newUser), config)
        .then((res) => {
          this.token = res.data.access_token;
        })
        .catch((err) => {
          console.log("CAN NOT ADD USER TO KEYCLOCK", err);
          this.falseAllErrorFlags();
          this.errKeycloak = true;
        });
      // ZAPYTANIE O UŻYTKOWNIKÓW + ZNALEZIENIE DODANEGO
      await axios
        .get(URL, config)
        .then((res) => {
          // console.log("SIEMA CO TAM? : ", res);
          const addedUserData = res.data.find(
            (user) => user.username === nickName
          );
          console.log("addedKEYCLOAKUserData: ", addedUserData.id);
          this.lastUserAddedIp = addedUserData.id;
        })
        .catch((err) => {
          console.log("CAN NOT FIND USER IN KEYCLOAK!!", err);
          this.falseAllErrorFlags();
          this.errKeycloak = true;
        });
    },
    async keycloakDellUser() {
      // najpierw token potem delete inaczej CORS!
      await this.GetToken();
      const KEYCLOCK_URL = `https://cookie-keycloak.mac.pl:8082`;
      const KEYCLOCK_REALM_NAME = "test";
      // na sztywno działa (już jest git)
      // const ID = "94e50553-ed14-462a-bded-8aa8cec6378f";
      const ID = this.lastUserAddedIp;
      console.log(this.lastUserAddedIp);
      //dlaczego zamienia wartosc ??
      const URL = `${KEYCLOCK_URL}/auth/admin/realms/${KEYCLOCK_REALM_NAME}/users/${ID}`;
      console.log(URL);
      if (ID) {
        const URL = `${KEYCLOCK_URL}/auth/admin/realms/${KEYCLOCK_REALM_NAME}/users/${ID}`;
        let config = {
          headers: {
            Authorization: "Bearer " + this.token,
            "Content-Type": "application/json",
          },
        };
        await axios
          .delete(URL, config)
          .then((res) => {
            console.log("DELETE USER FROM KEYCLOCK : ", res);
            this.falseAllErrorFlags();
            this.errKeycloak = true;
          })
          .catch((err) => {
            console.log("CANNOT DELETE ADDED USER! dlaczego?", err);
            this.falseAllErrorFlags();
            this.errKeycloak = true;
          });
      }
    },
    async addNewUserToMongo(nickName, firstName, lastName, email) {
      const newUser = {
        id: new Date().toISOString(),
        KeyID: this.lastUserAddedIp,
        "nick name": nickName,
        "first name": firstName,
        "last name": lastName,
        "email adress": email,
      };
      axios
        .post(`https://cookie-api.mac.pl:5000/new-keycloak-user`, newUser)
        .then((res) => {
          console.log("res przy dodaniu usera do mongo: ", res);
        })
        .catch((err) => {
          console.log("ERROR CAN NOT ADD USER TO MONGODB: ", err);
          this.keycloakDellUser();
        });
    },
    clearForm() {
      this.$refs.nickNameInput.value = "";
      this.$refs.passInput.value = "";
      this.$refs.emailInput.value = "";
      this.$refs.firstNameInput.value = "";
      this.$refs.lastNameInput.value = "";
    },
    showPassword() {
      // console.log("dupa", e);
      this.showPass = !this.showPass;
    },
    falseAllErrorFlags() {
      this.invalidForm = false;
      this.errKeycloak = false;
      this.successRegister = false;
    },
  },
};
</script>

<style scoped>
.register {
  text-align: center;
}
.main-panel {
  border-radius: 12px;
  box-shadow: 0 2px 8px rgba(0, 0, 0, 0.26);
  background-color: #eee;
  padding: 1rem;
  margin: 2rem auto;
  max-width: 40rem;
}
.error {
  color: red;
}
.success {
  color: green;
}
</style>
